summaryrefslogtreecommitdiffstats
path: root/source/ap/cups
diff options
context:
space:
mode:
Diffstat (limited to 'source/ap/cups')
-rw-r--r--source/ap/cups/3cd7b5e053f8100da1ca8d8daf93976cca3516ef.patch159
-rwxr-xr-xsource/ap/cups/cups.SlackBuild26
-rw-r--r--source/ap/cups/cups.url2
-rw-r--r--source/ap/cups/slack-desc10
4 files changed, 184 insertions, 13 deletions
diff --git a/source/ap/cups/3cd7b5e053f8100da1ca8d8daf93976cca3516ef.patch b/source/ap/cups/3cd7b5e053f8100da1ca8d8daf93976cca3516ef.patch
new file mode 100644
index 000000000..84ac77ed1
--- /dev/null
+++ b/source/ap/cups/3cd7b5e053f8100da1ca8d8daf93976cca3516ef.patch
@@ -0,0 +1,159 @@
+--- ./scheduler/auth.c.orig 2018-03-22 22:48:36.000000000 -0500
++++ ./scheduler/auth.c 2018-03-28 23:26:32.100862569 -0500
+@@ -71,9 +71,6 @@
+ static int compare_locations(cupsd_location_t *a,
+ cupsd_location_t *b);
+ static cupsd_authmask_t *copy_authmask(cupsd_authmask_t *am, void *data);
+-#if !HAVE_LIBPAM
+-static char *cups_crypt(const char *pw, const char *salt);
+-#endif /* !HAVE_LIBPAM */
+ static void free_authmask(cupsd_authmask_t *am, void *data);
+ #if HAVE_LIBPAM
+ static int pam_func(int, const struct pam_message **,
+@@ -694,14 +691,14 @@
+ * client...
+ */
+
+- pass = cups_crypt(password, pw->pw_passwd);
++ pass = crypt(password, pw->pw_passwd);
+
+ if (!pass || strcmp(pw->pw_passwd, pass))
+ {
+ # ifdef HAVE_SHADOW_H
+ if (spw)
+ {
+- pass = cups_crypt(password, spw->sp_pwdp);
++ pass = crypt(password, spw->sp_pwdp);
+
+ if (pass == NULL || strcmp(spw->sp_pwdp, pass))
+ {
+@@ -1995,129 +1992,6 @@
+ }
+
+
+-#if !HAVE_LIBPAM
+-/*
+- * 'cups_crypt()' - Encrypt the password using the DES or MD5 algorithms,
+- * as needed.
+- */
+-
+-static char * /* O - Encrypted password */
+-cups_crypt(const char *pw, /* I - Password string */
+- const char *salt) /* I - Salt (key) string */
+-{
+- if (!strncmp(salt, "$1$", 3))
+- {
+- /*
+- * Use MD5 passwords without the benefit of PAM; this is for
+- * Slackware Linux, and the algorithm was taken from the
+- * old shadow-19990827/lib/md5crypt.c source code... :(
+- */
+-
+- int i; /* Looping var */
+- unsigned long n; /* Output number */
+- int pwlen; /* Length of password string */
+- const char *salt_end; /* End of "salt" data for MD5 */
+- char *ptr; /* Pointer into result string */
+- _cups_md5_state_t state; /* Primary MD5 state info */
+- _cups_md5_state_t state2; /* Secondary MD5 state info */
+- unsigned char digest[16]; /* MD5 digest result */
+- static char result[120]; /* Final password string */
+-
+-
+- /*
+- * Get the salt data between dollar signs, e.g. $1$saltdata$md5.
+- * Get a maximum of 8 characters of salt data after $1$...
+- */
+-
+- for (salt_end = salt + 3; *salt_end && (salt_end - salt) < 11; salt_end ++)
+- if (*salt_end == '$')
+- break;
+-
+- /*
+- * Compute the MD5 sum we need...
+- */
+-
+- pwlen = strlen(pw);
+-
+- _cupsMD5Init(&state);
+- _cupsMD5Append(&state, (unsigned char *)pw, pwlen);
+- _cupsMD5Append(&state, (unsigned char *)salt, salt_end - salt);
+-
+- _cupsMD5Init(&state2);
+- _cupsMD5Append(&state2, (unsigned char *)pw, pwlen);
+- _cupsMD5Append(&state2, (unsigned char *)salt + 3, salt_end - salt - 3);
+- _cupsMD5Append(&state2, (unsigned char *)pw, pwlen);
+- _cupsMD5Finish(&state2, digest);
+-
+- for (i = pwlen; i > 0; i -= 16)
+- _cupsMD5Append(&state, digest, i > 16 ? 16 : i);
+-
+- for (i = pwlen; i > 0; i >>= 1)
+- _cupsMD5Append(&state, (unsigned char *)((i & 1) ? "" : pw), 1);
+-
+- _cupsMD5Finish(&state, digest);
+-
+- for (i = 0; i < 1000; i ++)
+- {
+- _cupsMD5Init(&state);
+-
+- if (i & 1)
+- _cupsMD5Append(&state, (unsigned char *)pw, pwlen);
+- else
+- _cupsMD5Append(&state, digest, 16);
+-
+- if (i % 3)
+- _cupsMD5Append(&state, (unsigned char *)salt + 3, salt_end - salt - 3);
+-
+- if (i % 7)
+- _cupsMD5Append(&state, (unsigned char *)pw, pwlen);
+-
+- if (i & 1)
+- _cupsMD5Append(&state, digest, 16);
+- else
+- _cupsMD5Append(&state, (unsigned char *)pw, pwlen);
+-
+- _cupsMD5Finish(&state, digest);
+- }
+-
+- /*
+- * Copy the final sum to the result string and return...
+- */
+-
+- memcpy(result, salt, (size_t)(salt_end - salt));
+- ptr = result + (salt_end - salt);
+- *ptr++ = '$';
+-
+- for (i = 0; i < 5; i ++, ptr += 4)
+- {
+- n = ((((unsigned)digest[i] << 8) | (unsigned)digest[i + 6]) << 8);
+-
+- if (i < 4)
+- n |= (unsigned)digest[i + 12];
+- else
+- n |= (unsigned)digest[5];
+-
+- to64(ptr, n, 4);
+- }
+-
+- to64(ptr, (unsigned)digest[11], 2);
+- ptr += 2;
+- *ptr = '\0';
+-
+- return (result);
+- }
+- else
+- {
+- /*
+- * Use the standard crypt() function...
+- */
+-
+- return (crypt(pw, salt));
+- }
+-}
+-#endif /* !HAVE_LIBPAM */
+-
+-
+ /*
+ * 'free_authmask()' - Free function for auth masks.
+ */
diff --git a/source/ap/cups/cups.SlackBuild b/source/ap/cups/cups.SlackBuild
index 58b3a2594..0cb5680ed 100755
--- a/source/ap/cups/cups.SlackBuild
+++ b/source/ap/cups/cups.SlackBuild
@@ -1,6 +1,6 @@
-#!/bin/sh
+#!/bin/bash
-# Copyright 2008, 2009, 2010, 2011, 2012, 2015 Patrick J. Volkerding, Sebeka, Minnesota, USA
+# Copyright 2008, 2009, 2010, 2011, 2012, 2015, 2017, 2018 Patrick J. Volkerding, Sebeka, Minnesota, USA
# All rights reserved.
#
# Redistribution and use of this script, with or without modification, is
@@ -22,9 +22,11 @@
# CUPS build script by volkerdi@slackware.com.
+cd $(dirname $0) ; CWD=$(pwd)
+
PKGNAM=cups
-VERSION=${VERSION:-$(echo $PKGNAM-*-source.tar.xz | cut -f 2 -d -)}
-BUILD=${BUILD:-1}
+VERSION=${VERSION:-$(echo $PKGNAM-*-source.tar.?z | cut -f 2 -d -)}
+BUILD=${BUILD:-2}
# Automatically determine the architecture we're building on:
if [ -z "$ARCH" ]; then
@@ -36,6 +38,14 @@ if [ -z "$ARCH" ]; then
esac
fi
+# If the variable PRINT_PACKAGE_NAME is set, then this script will report what
+# the name of the created package would be, and then exit. This information
+# could be useful to other scripts.
+if [ ! -z "${PRINT_PACKAGE_NAME}" ]; then
+ echo "$PKGNAM-$VERSION-$ARCH-$BUILD.txz"
+ exit 0
+fi
+
if [ "$ARCH" = "i586" ]; then
SLKCFLAGS="-O2 -march=i586 -mtune=i686"
LIBDIRSUFFIX=""
@@ -58,7 +68,6 @@ fi
NUMJOBS=${NUMJOBS:-" -j7 "}
-CWD=$(pwd)
TMP=${TMP:-/tmp}
PKG=$TMP/package-cups
@@ -67,9 +76,12 @@ mkdir -p $TMP $PKG
cd $TMP
rm -rf cups-$VERSION
-tar xvf $CWD/cups-$VERSION-source.tar.xz || exit 1
+tar xvf $CWD/cups-$VERSION-source.tar.?z || exit 1
cd cups-$VERSION || exit 1
+# Fix building without PAM:
+zcat $CWD/3cd7b5e053f8100da1ca8d8daf93976cca3516ef.patch.gz | patch -p1 --verbose || exit 1
+
sed -i.orig -e 's#$exec_prefix/lib/cups#$libdir/cups#g' configure
CFLAGS="$SLKCFLAGS" \
@@ -84,7 +96,7 @@ CXXFLAGS="$SLKCFLAGS" \
--disable-pam \
--disable-avahi \
--disable-dnssd \
- --build=$ARCH-slackware-linux
+ --build=$ARCH-slackware-linux || exit 1
make $NUMJOBS || exit 1
make BUILDROOT=$PKG install || exit 1
diff --git a/source/ap/cups/cups.url b/source/ap/cups/cups.url
index 1eb84ab8f..73e1dab3f 100644
--- a/source/ap/cups/cups.url
+++ b/source/ap/cups/cups.url
@@ -1 +1 @@
-https://github.com/apple/cups/releases/download/release-2.1.4/cups-2.1.4-source.tar.gz
+https://github.com/apple/cups/releases/download/v2.2.7/cups-2.2.7-source.tar.gz
diff --git a/source/ap/cups/slack-desc b/source/ap/cups/slack-desc
index c2e1643c9..d4d67164e 100644
--- a/source/ap/cups/slack-desc
+++ b/source/ap/cups/slack-desc
@@ -1,8 +1,8 @@
# HOW TO EDIT THIS FILE:
-# The "handy ruler" below makes it easier to edit a package description. Line
+# The "handy ruler" below makes it easier to edit a package description. Line
# up the first '|' above the ':' following the base package name, and the '|' on
-# the right side marks the last column you can put a character in. You must make
-# exactly 11 lines for the formatting to be correct. It's also customary to
+# the right side marks the last column you can put a character in. You must make
+# exactly 11 lines for the formatting to be correct. It's also customary to
# leave one space after the ':'.
|-----handy-ruler------------------------------------------------------|
@@ -11,8 +11,8 @@ cups:
cups: The Common UNIX Printing System provides a portable printing layer for
cups: UNIX(R)-like operating systems. It has been developed by Easy Software
cups: Products to promote a standard printing solution for all UNIX vendors
-cups: and users. CUPS uses the Internet Printing Protocol ("IPP") as the
-cups: basis for managing print jobs and queues. The CUPS package includes
+cups: and users. CUPS uses the Internet Printing Protocol ("IPP") as the
+cups: basis for managing print jobs and queues. The CUPS package includes
cups: System V and Berkeley command-line interfaces, a PostScript RIP
cups: package for supporting non-PostScript printer drivers, and tools for
cups: creating additional printer drivers and other CUPS services.